﻿Public Class formChipEdit
    'Public imgTemp As Image()
    Public selChip As Point
    Public picChipWinTapping As Boolean
    Const CHIP_SIZE As Integer = 16
    Const fRenderScale As Single = 1.5
    Public iCurrentRetryBuff As Integer
    Public bBtnClose As Boolean
    Private Sub formChipEdit_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        txtChipID.Maximum = Form1.iChipMax - 1
        txtChipID.Value = Form1.iChipID
        txtChipDat_setVal()
        iCurrentRetryBuff = 0
        write_iChipDatBuff()
    End Sub
    Private Sub formChipEdit_FormClosing(sender As Object, e As FormClosingEventArgs) Handles MyBase.FormClosing
        If e.CloseReason = CloseReason.UserClosing Then
            If Not bBtnClose Then
                If MsgBox("チップセットを保存せず閉じてOKですか？", MsgBoxStyle.YesNo, "確認") = MsgBoxResult.No Then
                    '「いいえ」⇒閉じるのを止める
                    e.Cancel = True
                Else '「はい」→チップセットデータを元戻し
                    Read_iChipDatBuff(0)
                End If
            End If
        End If
        bBtnClose = False
    End Sub

    Private Sub picChipWindow_Paint(sender As Object, e As PaintEventArgs) Handles picChipWindow.Paint

        Dim width As Integer
        Dim height As Integer
        width = CHIP_SIZE * 16
        height = CHIP_SIZE * 16

        '切り取る部分の範囲を決定する。
        Dim srcRect As New Rectangle(0, 0, width * Form1.fBaseScale - 1, height * Form1.fBaseScale - 1)
        '描画する部分の範囲を決定する。
        Dim desRect As New Rectangle(0, 0, width * fRenderScale, height * fRenderScale)
        '画像の一部を描画する
        'g.DrawImage(img, desRect, srcRect, GraphicsUnit.Pixel)
        e.Graphics.DrawImage(Form1.imgTemp(Form1.iChipID), desRect, srcRect, GraphicsUnit.Pixel)


        '---選択中のチップを囲む
        Dim tx As Integer = selChip.X
        Dim ty As Integer = selChip.Y

        Dim p As New Pen(Color.Red, 2)
        Dim q As New Pen(Color.Blue, 2)

        Dim tWidth = 1

        Dim tHeight = 1
        Dim tLeft = tx * CHIP_SIZE * fRenderScale
        Dim tTop = ty * CHIP_SIZE * fRenderScale
        e.Graphics.DrawRectangle(p, tLeft, tTop, tWidth * CHIP_SIZE * fRenderScale, tHeight * CHIP_SIZE * fRenderScale)
        e.Graphics.DrawRectangle(q, tLeft + 2, tTop + 2, tWidth * CHIP_SIZE * fRenderScale, tHeight * CHIP_SIZE * fRenderScale)
        p.Dispose()
        q.Dispose()
    End Sub

    Private Sub picChipWindow_MouseDown(sender As Object, e As MouseEventArgs) Handles picChipWindow.MouseDown
        picChipWindow.Focus() 'txtChipDatからフォーカスを奪ってうことでデータ更新させる
        picChipWinTapping = True
        picChipWin_Sel()
        txtChipDat.Focus() 'txtChipDatにフォーカスを戻し、次の入力をスムーズに
        txtChipDat.SelectAll()
    End Sub

    Private Sub picChipWindow_MouseMove(sender As Object, e As MouseEventArgs) Handles picChipWindow.MouseMove
        If picChipWinTapping Then
            picChipWin_Sel()
        End If
    End Sub

    Private Sub picChipWindow_MouseUp(sender As Object, e As MouseEventArgs) Handles picChipWindow.MouseUp
        picChipWinTapping = False
    End Sub
    Private Sub picChipWin_Sel()
        Dim Pos As Point = picChipWindow.PointToClient(Windows.Forms.Cursor.Position)
        Dim tx As Integer = Pos.X
        Dim ty As Integer = Pos.Y

        selChip.X = (tx - CHIP_SIZE) / (CHIP_SIZE * fRenderScale)
        selChip.Y = (ty - CHIP_SIZE) / (CHIP_SIZE * fRenderScale)


        If selChip.X < 0 Then
            selChip.X = 0
        ElseIf selChip.X > CHIP_SIZE - 1 Then
            selChip.X = CHIP_SIZE - 1
        End If

        If selChip.Y < 0 Then
            selChip.Y = 0
        ElseIf selChip.y > CHIP_SIZE - 1 Then
            selChip.Y = CHIP_SIZE - 1
        End If

        picChipWindow.Invalidate()

        txtChipDat_setVal()
        rdb_setChecked()

        statusLbl.Text = "x:" & selChip.X & ",Y:" & selChip.Y
    End Sub
    Private Sub txtChipDat_setVal()
        txtChipDat.Text = Form1.iChipDat(Form1.iChipID, selChip.X, selChip.Y)
    End Sub
    Private Sub rdb_setChecked()
        Dim val As Integer = Form1.iChipDat(Form1.iChipID, selChip.X, selChip.Y)

        If val And &H1 Then
            rdb0_1.Checked = True
        Else
            rdb0_0.Checked = True
        End If

        If val And &H2 Then
            rdb1_1.Checked = True
        Else
            rdbF1_0.Checked = True
        End If

        If val And &H4 Then
            rdb2_1.Checked = True
        Else
            rdb2_0.Checked = True
        End If

        If val And &H8 Then
            rdb3_1.Checked = True
        Else
            rdb3_0.Checked = True
        End If

        If val And &H10 Then
            rdb4_1.Checked = True
        Else
            rdb4_0.Checked = True
        End If

        If val And &H20 Then
            rdb5_1.Checked = True
        Else
            rdb5_0.Checked = True
        End If

        If val And &H40 Then
            rdb6_1.Checked = True
        Else
            rdb6_0.Checked = True
        End If

        If val And &H80 Then
            rdb7_1.Checked = True
        Else
            rdb7_0.Checked = True
        End If
    End Sub
    Private Sub fixChipDat()
        Form1.iChipDat(Form1.iChipID, selChip.X, selChip.Y) = Integer.Parse(txtChipDat.Text)
    End Sub
    Private Sub fixTxtChipDat()
        Dim setVal As Integer
        setVal = (rdb0_1.Checked * 2 ^ 0) + (rdb1_1.Checked * 2 ^ 1) + (rdb2_1.Checked * 2 ^ 2) + (rdb3_1.Checked * 2 ^ 3) + (rdb4_1.Checked * 2 ^ 4) + (rdb5_1.Checked * 2 ^ 5) + (rdb6_1.Checked * 2 ^ 6) + (rdb7_1.Checked * 2 ^ 7)
        txtChipDat.Text = -setVal
    End Sub
    Private Sub txtChipDat_LostFocus(sender As Object, e As EventArgs) Handles txtChipDat.LostFocus
        fixChipDat()
    End Sub
    Private Sub rdbToho0_Click(sender As Object, e As EventArgs) Handles rdb0_0.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbToho1_Click(sender As Object, e As EventArgs) Handles rdb0_1.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbFune0_Click(sender As Object, e As EventArgs) Handles rdbF1_0.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbFune1_Click(sender As Object, e As EventArgs) Handles rdb1_1.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbSky0_Click(sender As Object, e As EventArgs) Handles rdb2_0.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbSky1_Click(sender As Object, e As EventArgs) Handles rdb2_1.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbYobi0_0_Click(sender As Object, e As EventArgs) Handles rdb3_0.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbYobi0_1_Click(sender As Object, e As EventArgs) Handles rdb3_1.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbDown0_Click(sender As Object, e As EventArgs) Handles rdb4_0.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbDown1_Click(sender As Object, e As EventArgs) Handles rdb4_1.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbLeft0_Click(sender As Object, e As EventArgs) Handles rdb5_0.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbLeft1_Click(sender As Object, e As EventArgs) Handles rdb5_1.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbUp0_Click(sender As Object, e As EventArgs) Handles rdb6_0.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbUp1_Click(sender As Object, e As EventArgs) Handles rdb6_1.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbRight0_Click(sender As Object, e As EventArgs) Handles rdb7_0.Click
        fixTxtChipDat()
    End Sub
    Private Sub rdbRight1_Click(sender As Object, e As EventArgs) Handles rdb7_1.Click
        fixTxtChipDat()
    End Sub

    Private Sub write_iChipDatBuff()
        iCurrentRetryBuff = iCurrentRetryBuff + 1
        If iCurrentRetryBuff >= Form1.iRetryBuffMax Then
            iCurrentRetryBuff = 0
        End If

        Dim x As Integer
        Dim y As Integer
        For y = 0 To Form1.CHIPDATMAX_Y - 1
            For x = 0 To Form1.CHIPDATMAX_X - 1
                Form1.iChipDatBuff(iCurrentRetryBuff, x, y) = Form1.iChipDat(Form1.iChipID, x, y)
            Next x
        Next y
    End Sub
    Private Sub Read_iChipDatBuff(iDirection As Integer)
        iCurrentRetryBuff = iCurrentRetryBuff + iDirection
        If iCurrentRetryBuff < 0 Then
            iCurrentRetryBuff = Form1.iRetryBuffMax + iDirection
        ElseIf iCurrentRetryBuff >= Form1.iRetryBuffMax Then
            iCurrentRetryBuff = 0
        End If

        Dim x As Integer
        Dim y As Integer
        For y = 0 To Form1.CHIPDATMAX_Y - 1
            For x = 0 To Form1.CHIPDATMAX_X - 1
                Form1.iChipDat(Form1.iChipID, x, y) = Form1.iChipDatBuff(iCurrentRetryBuff, x, y)
            Next x
        Next y

    End Sub

    Private Sub btnOkay_Click(sender As Object, e As EventArgs) Handles btnOkay.Click
        Form1.saveChipData()
        Form1.saveChipData_BMP()
        bBtnClose = True
        Me.Close()
    End Sub

    Private Sub txtChipID_ValueChanged(sender As Object, e As EventArgs) Handles txtChipID.ValueChanged
        Form1.iChipID = Integer.Parse(txtChipID.Value)
        'Form1.LoadChipData("chip\\chip" & Form1.iChipID & ".txt")
        picChipWindow.Invalidate()
        Form1.picMapWindow.Invalidate()
        Form1.picChipWindow.Invalidate()
    End Sub

End Class